VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "HTMLHelp"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

Private Type RECT
    Left    As Long
    Top     As Long
    Right   As Long
    Bottom  As Long
End Type

Private Type POINTAPI
    x As Long
    y As Long
End Type

Private Declare Function GetCursorPos Lib "user32.dll" _
    (lpPoint As POINTAPI) As Long

Private Type tagHH_FTS_QUERY
    cbStruct          As Long
    fUniCodeStrings   As Long
    pszSearchQuery    As String
    iProximity        As Long
    fStemmedSearch    As Long
    fTitleOnly        As Long
    fExecute          As Long
    pszWindow         As String
End Type

Private Type tagHH_POPUP
    cbStruct          As Long
    hinst             As Long
    idString          As Long
    pszText           As String
    pt                As POINTAPI
    clrForeground     As Long
    clrBackground     As Long
    rcMargins         As RECT
    pszFont           As String
End Type

Private Declare Function HtmlHelp Lib "HHCtrl.ocx" Alias "HtmlHelpA" _
    (ByVal HWndCaller As Long, _
     ByVal pszFile As String, _
     ByVal uCommand As Long, _
     dwData As Any) As Long

Const HH_DISPLAY_TOPIC As Long = &H0
Const HH_DISPLAY_TOC As Long = &H1
Const HH_DISPLAY_INDEX As Long = &H2
Const HH_DISPLAY_SEARCH As Long = &H3
Const HH_DISPLAY_TEXT_POPUP As Long = &HE
Const HH_HELP_CONTEXT As Long = &HF
Const HH_CLOSE_ALL As Long = &H12
Const HH_INITIALIZE As Long = &H1C
Const HH_UNINITIALIZE As Long = &H1D

'''

Private lCookie As Long

Private lHWndCaller As Long
Private sFilename As String
Private bShowOnTop As Boolean

Private hWndHelp As Long

'''

Public Property Get HWnd() As Long
    HWnd = lHWndCaller
End Property
Public Property Let HWnd(NewVal As Long)
    lHWndCaller = NewVal
End Property

Public Property Get Filename() As String
    Filename = sFilename
End Property
Public Property Let Filename(NewVal As String)
    sFilename = NewVal
End Property

Public Property Get ShowOnTop() As Boolean
    ShowOnTop = bShowOnTop
End Property
Public Property Let ShowOnTop(ByVal NewVal As Boolean)
    bShowOnTop = NewVal
End Property

'''

Public Sub ShowTopic(sID As String)
    Dim HWnd As Long
    
    If bShowOnTop Then
        HWnd = lHWndCaller
    Else
        HWnd = 0
    End If
    
    hWndHelp = HtmlHelp(HWnd, sFilename, HH_DISPLAY_TOPIC, ByVal sID + ".htm")
End Sub

Public Sub ShowContents()
    Dim HWnd As Long
    
    If bShowOnTop Then
        HWnd = lHWndCaller
    Else
        HWnd = 0
    End If
    
    hWndHelp = HtmlHelp(HWnd, sFilename, HH_DISPLAY_TOC, ByVal 0&)
End Sub

Public Sub ShowIndex()
    Dim HWnd As Long
    
    If bShowOnTop Then
        HWnd = lHWndCaller
    Else
        HWnd = 0
    End If
    
    hWndHelp = HtmlHelp(HWnd, sFilename, HH_DISPLAY_INDEX, ByVal 0&)
End Sub

Public Sub ShowSearch()
    Dim HH_FTS_QUERY As tagHH_FTS_QUERY
    Dim HWnd As Long

    With HH_FTS_QUERY
        .cbStruct = Len(HH_FTS_QUERY)
        .fUniCodeStrings = 0&
        .pszSearchQuery = ""
        .iProximity = 0&
        .fStemmedSearch = 0&
        .fTitleOnly = 0&
        .fExecute = 1&
        .pszWindow = ""
    End With
    
    If bShowOnTop Then
        HWnd = lHWndCaller
    Else
        HWnd = 0
    End If
    
    hWndHelp = HtmlHelp(HWnd, sFilename, HH_DISPLAY_SEARCH, HH_FTS_QUERY)
End Sub

Public Sub ShowPopupText(sText As String)
    Dim tPoint As POINTAPI
    Dim tPopup As tagHH_POPUP
    Dim tRect As RECT
    Dim sFont As String
    
    GetCursorPos tPoint
    
    With tRect
        .Bottom = -1
        .Left = -1
        .Right = -1
        .Top = -1
    End With
    
    sFont = "Arial, 10"
    
    With tPopup
        .cbStruct = Len(tPopup)
        .idString = 0
        .pszText = sText
        .pt = tPoint
        .clrForeground = 0
        .clrBackground = 0
        .rcMargins = tRect
        .pszFont = sFont
    End With
  
    If bShowOnTop Then
        HWnd = lHWndCaller
    Else
        HWnd = 0
    End If
  
    hWndHelp = HtmlHelp(HWnd, vbNullString, HH_DISPLAY_TEXT_POPUP, tPopup)
End Sub

Public Sub CloseAll(ByVal HWndCaller As Long)
    hWndHelp = HtmlHelp(HWndCaller, vbNullString, HH_CLOSE_ALL, ByVal 0&)
End Sub

'''

Private Sub Class_Initialize()
    HtmlHelp vbNull, vbNullString, HH_INITIALIZE, lCookie
    bShowOnTop = True
End Sub

Private Sub Class_Terminate()
    HtmlHelp vbNull, vbNullString, HH_CLOSE_ALL, ByVal 0&
    HtmlHelp vbNull, vbNullString, HH_UNINITIALIZE, ByVal lCookie
End Sub
